package pipe.gui;

import pipe.dataLayer.*;

import javax.swing.*;
import java.util.*;
import java.util.Observable;
import java.awt.*;
import java.awt.event.*;
import java.awt.event.MouseEvent;

import javax.swing.event.MouseInputAdapter;



/**
 * Class used to implement methods corresponding to mouse events on places.
 *
 */

public class CreateArcHandler extends MouseInputAdapter implements Constants {


  protected Container contentPane;
  //    protected PetriNetObject tempPnobject;
  protected CreateGui theApp;
  protected boolean animationmode;

  int aStartx;
  int aStarty;
  int aEndx;
  int aEndy;

  private static int counter = 0;

  PlaceTransitionObject source;
  PlaceTransitionObject target;
  boolean drawing;
  String startClass;
  String endClass;


  // constructor passing in all required objects
  public CreateArcHandler(CreateGui creategui, Container contentpane) {
    //super(creategui,contentpane);
    contentPane = contentpane;
    theApp =creategui;
    source = null;
    drawing = false;
    counter++;

  }


  public void disableDrawing() {
    drawing = false;
  }


  public void mousePressed(MouseEvent e) {
    if (e.getButton() == MouseEvent.BUTTON3) {
      // prevent accidental deletions
      return;
    }
    if(ModeAdaptor.getMode() <=103){
      animationmode = true;
    }
    else {
      animationmode = false;
    }

    if(animationmode == true){
      return;
    }
    else {

      if (!drawing) {
        PlaceTransitionObject selected = (PlaceTransitionObject)e.getComponent();
        startClass = selected.getClass().getName();

        // store for later use
        source = selected;

        int mode = ModeAdaptor.getMode();
        switch(mode) {
          case ARC:
            drawing = true;
            aStartx = selected.getX();
            aStarty = selected.getY();
            // add the insets and offset
            aStartx += selected.leftOffset();
            aStarty += selected.topOffset();
            break;
        }
        selected = null;

      } else {

        PlaceTransitionObject selected = (PlaceTransitionObject)e.getComponent();
        target = selected;

        // we need to make sure we can't connect like components
        String targetClass = selected.getClass().getName();

        if ((selected != source) && (drawing) && (!startClass.equals(targetClass) )) {
          int mode = ModeAdaptor.getMode();
          switch(mode) {
            case ARC:

              aEndx = selected.getX();
              aEndy = selected.getY();
              aEndx += selected.leftOffset();
              aEndy += selected.topOffset();

              double _startx = aStartx;
              double _starty = aStarty;
              double _endx = aEndx;
              double _endy = aEndy;


              Arc arc = new Arc(_startx,_starty,_endx,_endy,source,target,null,Color.BLACK);
              ArcHandler arcHandler = new ArcHandler(theApp,contentPane);

              ArrowLabel arrow = new ArrowLabel(arc);
              arc.setArrow(arrow);

              theApp.getModel().addArc(arc);
              theApp.getModel().addPetriNetObject(arrow);

              contentPane.repaint();

              //arc.setBorder(BorderFactory.createLineBorder(Color.BLACK));
              drawing = false;
              break;
          }

        }
        selected = null;
      }
    }
  }
}







